Subject: Re: gcc-dw2? or fast sjlj-exceptions EH
From: Tatsuro MATSUOKA <[email-masked]>
To: Danny Smith <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Tue, 11 Sep 2007 07:51:36 +0900
List-Id: <cygwin.cygwin.com>

Thank you Danny.

My ability is not high enough so that I will discuss your suggestion 
in the Octave ML.

Tatsuro MATSUOKA

Danny Smith <[email-masked]> wrote:
(2007/09/11 07:06)

>At http://www.cygwin.com/ml/cygwin/2007-09/msg00194.html
>
>Tatsuro Matsuoka wrote:
>
>> The best solution, I think, the speed of sjlj-exceptions EH on the 
>> cygwin is as fast as that of other platforms.
>> 
>
>In the case of octave, I believe that the main cause of slowdown is the
>sjlj EH code generated in prologue of new()
>Does a no-throw override of libary version of these functions help ?  
>
>
>Danny
>#ifdef __USING_SJLJ_EXCEPTIONS__
>#define NEW_THROW_SPEC throw()
>#else
>#define NEW_THROW_SPEC throw(std::bad_alloc)
>#endif 
>
>#include ...
>
>void *
>operator new (std::size_t sz) NEW_THROW_SPEC
>{
>  void *p;
>
>  /* malloc (0) is unpredictable; avoid it.  */
>  if (sz == 0)
>    sz = 1;
>  p = (void *) malloc (sz);
>  while (p == 0)
>    {
>      new_handler handler = __new_handler;
>      if (! handler)
>#ifdef __USING_SJLJ_EXCEPTIONS__
>        std::abort();
>#else
>	  throw bad_alloc();
>#endif
>      handler ();
>      p = (void *) malloc (sz);
>    }
>
>  return p;
>}
>
>void *
>operator new[] (std::size_t sz) NEW_THROW_SPEC
>{
>  return ::operator new(sz);
>}
>
>
>--
>Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
>Problem reports:       http://cygwin.com/problems.html
>Documentation:         http://cygwin.com/docs.html
>FAQ:                   http://cygwin.com/faq/

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/